cinvoke equ CINVOKE
cinvoket equ CINVOKET
lpcinvoke equ LPCINVOKE
lpcinvoket equ LPCINVOKET
cfunc equ CFUNC
lpcfunc equ LPCFUNC
lpcfunct equ LPCFUNCT
;Similar to FUNC
CFUNC MACRO parameters:VARARG
	cinvoke parameters
	EXITM <eax>
ENDM
; Call Methods of some COM object declared with COM or LCOM
CINVOKE	MACRO	Nombre, func, arglist :VARARG ; DO NOT use edx as argument
	FOR var, <arglist>
		IFIDNI <"&var">, <"edx">
			.ERR <EDX NOT allowed as argument> 
		ENDIF
	ENDM 
	mov			edx , Nombre
	mov			edx , [edx]
	ASSUME EDX: PTR _Interface_&Nombre&
	IFB <arglist>
		INVOKE [edx].func, Nombre
	ELSE
		INVOKE [edx].func, Nombre, arglist
	ENDIF
	ASSUME EDX:NOTHING
ENDM
; Similar to CFUNC but it checks if the object is valid before calling any method
CFUNCT MACRO parameters:VARARG
	cinvoket parameters
	EXITM <eax>
ENDM
; Similar to CInvoke but it checks if the object is valid before calling any method
CINVOKET	MACRO	Nombre, func, arglist :VARARG ; No usar edx como argumento
	FOR var, <arglist>
		IFIDNI <"&var">, <"edx">
			.ERR <EDX NOT allowed as argument> 
		ENDIF
	ENDM 
	mov			edx , Nombre
	.IF		edx	!= 0
		mov			edx , [edx]
		ASSUME EDX: PTR _Interface_&Nombre&
		IFB <arglist>
			INVOKE [edx].func, Nombre
		ELSE
			INVOKE [edx].func, Nombre, arglist
		ENDIF
	.ENDIF
	ASSUME EDX:NOTHING
ENDM

; Call a method of a COM object that is inside an array of COM objects pointed by 
; COMArray
; Note: COMArray must be a variable previously declared with COM or LCOM
; Example: 
; Suppouse that lp_Textures is a pointer to an array of COMs IDirect3DTexture9
; must be declared as: COM lp_Textures, IDirect3DTexture9 or LCOM lp_Textures, IDirect3DTexture9
; To call any method: lpcinvoke lp_Textures, NumberOfComToCall - 1, Release
; Suppouse we want to call the second object in the array, i should type [lpcinvoke lp_Textures, 1, Release]
; More info: lp_Textures must be a pointer to an array of COM objects of the same
; type and the array must be created with [GlobalAlloc, GMEM_FIXED, NumbreOfCOM * 4] 
; then lp_Textures must be assigned the result of this fuction, each DWORD of the array
; created must be initialized with some COM object or to ZERO to prevent craching
; Look for an example of the use of this macro in Tutorial 6 - Using meshes.wap
LPCINVOKE MACRO COMArray, Indice, func, arglist:VARARG
	FOR var, <arglist>
		IFIDNI <"&var">, <"edx">
			.ERR <EDX NOT allowed as argument> 
		ELSEIFIDNI <"&var">, <"ecx">
			.ERR <ECX NOT allowed as argument> 
		ENDIF
	ENDM 
	mov		edx, COMArray
	mov		ecx, Indice
	mov		edx, [edx + ecx*4]
	mov		ecx, [edx]
	ASSUME ECX: PTR _Interface_&COMArray&
	IFB <arglist>
		INVOKE [ecx].func, edx
	ELSE
		INVOKE [ecx].func, edx, arglist
	ENDIF
	ASSUME ECX:NOTHING
EndM
; Similar to LPCINVOKE but with cheking
LPCINVOKET MACRO COMArray, Indice, func, arglist:VARARG
	FOR var, <arglist>
		IFIDNI <"&var">, <"edx">
			.ERR <No se permite usar como argumento EDX> 
		ELSEIFIDNI <"&var">, <"ecx">
			.ERR <No se permite usar como argumento ECX>
		ENDIF
	ENDM 
	mov		edx, COMArray
	mov		ecx, Indice
	mov		edx, [edx + ecx*4]
	.IF 	edx != 0
		mov		ecx, [edx]
		ASSUME ECX: PTR _Interface_&COMArray&
		IFB <arglist>
			INVOKE [ecx].func, edx
		ELSE
			INVOKE [ecx].func, edx, arglist
		ENDIF
		ASSUME ECX:NOTHING
	.ENDIF
EndM
; Similar to FUNC but using COMs stored in arrays, see LPCINVOKE
LPCFUNC MACRO parameters:VARARG
	lpcinvoke parameters
	EXITM <eax>
EndM
; Similar to LPCFUNC but with checking
LPCFUNCT MACRO parameters:VARARG
	lpcinvoket parameters
	EXITM <eax>
EndM

; Create a COM variable in DATA section
COM MACRO Nombre, Interface
	Nombre dd 0
	_Interface_&Nombre& equ <&Interface&>
endm
; Create a LOCAL COM variable inside a PROC
LCOM MACRO Nombre, Interface
	%LOCAL &Nombre&:DWORD
	_Interface_&Nombre& equ <&Interface&>
EndM

; This macro is similar to the included in the MASM32 Pack.
coinvoke MACRO pInterface:REQ, Interface:REQ, Function:REQ, args:VARARG
    LOCAL istatement, arg
    FOR arg, <args>     ;; run thru args to see if edx is lurking in there
        IFIDNI <&arg>, <edx>
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
    istatement CATSTR <invoke (Interface PTR[edx]).&Function, pInterface>
    IFNB <args>     ;; add the list of parameter arguments if any
        istatement CATSTR istatement, <, >, <&args> 
    ENDIF 
    ECHO istatement
    mov edx, pInterface
    mov edx, [edx]
    istatement
ENDM

; FPU Constants
FPU_C0 EQU 0100h
FPU_C1 EQU 0200h
FPU_C2 EQU 0400h
FPU_C3 EQU 4000h
FPU_ROUND_NEAREST 	EQU 03FFh 
FPU_ROUND_DOWNWARDS	EQU 07FFh 
FPU_ROUND_UPWARDS 	EQU 0BFFh 
FPU_ROUND_TRUNCATE 	EQU 0FFFh 


; STDMETHOD FncName, VARARG ; See D3DX9.INC
; This macro is used to create de VTable of the interface
;	Ej: STDMETHOD InputCallback, :DWORD
STDMETHOD	MACRO	name, argl :VARARG
LOCAL @tmp_a
LOCAL @tmp_b

@tmp_a	TYPEDEF PROTO argl
@tmp_b	TYPEDEF PTR @tmp_a
name		@tmp_b		?
ENDM

;Similar to STDMETHOS but using C Call conversion
STDMETHODC	MACRO	name, argl :VARARG
LOCAL @tmp_a
LOCAL @tmp_b

@tmp_a	TYPEDEF PROTO C argl
@tmp_b	TYPEDEF PTR @tmp_a
name		@tmp_b		?
ENDM

; ///////////////////////////////////////////////////////////////////////////
; //			Constant an interfaces not defined in Windows.inc		   //
; ///////////////////////////////////////////////////////////////////////////
VARIANT_BOOL    TYPEDEF     WORD
PVOID           TYPEDEF     DWORD
BSTR            TYPEDEF     DWORD
VARTYPE         TYPEDEF     WORD
LCID            TYPEDEF     DWORD
HREFTYPE        TYPEDEF     DWORD
PVOID           TYPEDEF     DWORD
SCODE           TYPEDEF     DWORD
DISPID          TYPEDEF     DWORD
MEMBERID        TYPEDEF     DWORD 
HREFTYPE        TYPEDEF     DWORD 
IEnumMoniker STRUCT
        STDMETHOD QueryInterface, :DWORD, :DWORD, :DWORD
        STDMETHOD AddRef, :DWORD        
        STDMETHOD Release, :DWORD
        STDMETHOD Next, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD Skip, :DWORD, :DWORD
        STDMETHOD Reset, :DWORD
        STDMETHOD Clone, :DWORD, :DWORD
IEnumMoniker EndS
IMoniker STRUCT
        STDMETHOD QueryInterface, :DWORD, :DWORD, :DWORD
        STDMETHOD AddRef, :DWORD
        STDMETHOD Release, :DWORD
        STDMETHOD GetClassID, :DWORD, :DWORD
        STDMETHOD IsDirty, :DWORD
        STDMETHOD Load, :DWORD, :DWORD
        STDMETHOD Save, :DWORD, :DWORD, :DWORD
        STDMETHOD GetSizeMax, :DWORD, :DWORD
        STDMETHOD BindToObject, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD BindToStorage, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD Reduce, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD ComposeWith, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD Enum, :DWORD, :DWORD, :DWORD
        STDMETHOD IsEqual, :DWORD, :DWORD
        STDMETHOD Hash, :DWORD, :DWORD
        STDMETHOD IsRunning, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD GetTimeOfLastChange, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD Inverse, :DWORD, :DWORD
        STDMETHOD CommonPrefixWith, :DWORD, :DWORD, :DWORD
        STDMETHOD RelativePathTo, :DWORD, :WORD, :DWORD
        STDMETHOD GetDisplayName, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD ParseDisplayName, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD IsSystemMoniker, :DWORD, :DWORD
IMoniker EndS
IPropertyBag STRUCT
        STDMETHOD QueryInterface, :DWORD, :DWORD, :DWORD
        STDMETHOD AddRef, :DWORD
        STDMETHOD Release, :DWORD
        STDMETHOD Read, :DWORD, :DWORD, :DWORD, :DWORD
        STDMETHOD Write, :DWORD, :DWORD, :DWORD
IPropertyBag EndS
VARIANT STRUCT 
    vt              WORD            VT_EMPTY
    wReserved1      WORD            0
    wReserved2      WORD            0
    wReserved3      WORD            0
    Union
        lVal            SDWORD          ?   ; VT_I4
        bVal            WORD            ?   ; VT_UI1
        iVal            SWORD           ?   ; VT_I2
        fltVal          REAL4           ?   ; VT_R4
        dblVal          REAL8           ?   ; VT_R8
        boolVal         VARIANT_BOOL    ?   ; VT_BOOL
        scode           SCODE           ?   ; VT_ERROR
        cyVal           QWORD           ?   ; VT_CY
        date            QWORD           ?   ; VT_DATE
        bstrVal         BSTR            ?   ; VT_BSTR
        punkVal         PVOID           ?   ; VT_UNKNOWN
        pdispVal        PVOID           ?   ; VT_DISPATCH
        parray          PVOID           ?   ; VT_ARRAY
        pbVal           PVOID           ?   ; VT_BYREF|VT_UI1
        piVal           PVOID           ?   ; VT_BYREF|VT_I2
        plVal           PVOID           ?   ; VT_BYREF|VT_I4
        pfltVal         PVOID           ?   ; VT_BYREF|VT_R4
        pdblVal         PVOID           ?   ; VT_BYREF|VT_R8
        pboolVal        PVOID           ?   ; VT_BYREF|VT_BOOL
        pscode          PVOID           ?   ; VT_BYREF|VT_ERROR
        pcyVal          PVOID           ?   ; VT_BYREF|VT_CY
        pdate           PVOID           ?   ; VT_BYREF|VT_DATE
        pbstrVal        PVOID           ?   ; VT_BYREF|VT_BSTR
        ppunkVal        PVOID           ?   ; VT_BYREF|VT_UNKNOWN
        ppdispVal       PVOID           ?   ; VT_BYREF|VT_DISPATCH
        pparray         PVOID           ?   ; VT_BYREF|VT_ARRAY
        pvarVal         PVOID           ?   ; VT_BYREF|VT_VARIANT
        byref           PVOID           ?   ; Generic ByRef
        cVal            SBYTE           ?   ; VT_I1
        uiVal           WORD            ?   ; VT_UI2
        ulVal           DWORD           ?   ; VT_UI4
        intVal          SWORD           ?   ; VT_int
        uintVal         WORD            ?   ; VT_uint
        pdecVal         PVOID           ?   ; VT_BYREF|VT_DECIMAL
        pcVal           PVOID           ?   ; VT_BYREF|VT_I1
        puiVal          PVOID           ?   ; VT_BYREF|VT_UI2
        pulVal          PVOID           ?   ; VT_BYREF|VT_UI4
        pintVal         PVOID           ?   ; VT_BYREF|VT_int
        puintVal        PVOID           ?   ; VT_BYREF|VT_uint
    ENDS
VARIANT ENDS
