; ====================================
;                               GUIDS
; ====================================
IID_IDirectSound3DBuffer    GUID {0279AFA86h, 04981h, 011CEh, {0A5h, 021h, 000h, 020h, 0AFh, 00Bh, 0E5h, 060h}}
IID_IDirectSound3DListener8  GUID {0279AFA84h, 04981h, 011CEh, {0A5h, 021h, 000h, 020h, 0AFh, 00Bh, 0E5h, 060h}}


; ====================================
;                             METHODS
; ====================================

IDirectSound3DBuffer8 STRUCT
;    // IUnknown methods
    STDMETHOD QueryInterface, :PTR IDirectSound3DBuffer8
    STDMETHOD AddRef, :PTR IDirectSound3DBuffer8        
    STDMETHOD Release, :PTR IDirectSound3DBuffer8       

;    // IDirectSound3DBuffer methods
    STDMETHOD GetAllParameters, :PTR IDirectSound3DBuffer8     
    STDMETHOD GetConeAngles, :PTR IDirectSound3DBuffer8        
    STDMETHOD GetConeOrientation, :PTR IDirectSound3DBuffer8   
    STDMETHOD GetConeOutsideVolume, :PTR IDirectSound3DBuffer8 
    STDMETHOD GetMaxDistance, :PTR IDirectSound3DBuffer8       
    STDMETHOD GetMinDistance, :PTR IDirectSound3DBuffer8       
    STDMETHOD GetMode, :PTR IDirectSound3DBuffer8              
    STDMETHOD GetPosition, :PTR IDirectSound3DBuffer8          
    STDMETHOD GetVelocity, :PTR IDirectSound3DBuffer8          
    STDMETHOD SetAllParameters, :PTR IDirectSound3DBuffer8     
    STDMETHOD SetConeAngles, :PTR IDirectSound3DBuffer8        
    STDMETHOD SetConeOrientation, :PTR IDirectSound3DBuffer8   
    STDMETHOD SetConeOutsideVolume, :PTR IDirectSound3DBuffer8 
    STDMETHOD SetMaxDistance, :PTR IDirectSound3DBuffer8       
    STDMETHOD SetMinDistance, :PTR IDirectSound3DBuffer8       
    STDMETHOD SetMode, :PTR IDirectSound3DBuffer8              
    STDMETHOD SetPosition, :PTR IDirectSound3DBuffer8, :DWORD, :DWORD, :DWORD, :DWORD
    STDMETHOD SetVelocity, :PTR IDirectSound3DBuffer8, :DWORD, :DWORD, :DWORD, :DWORD          
IDirectSound3DBuffer8 ENDS

IDirectSoundBuffer8 STRUCT
;    // IUnknown methods
    STDMETHOD QueryInterface, :PTR IDirectSoundBuffer8, :DWORD, :DWORD
    STDMETHOD AddRef, :PTR IDirectSoundBuffer8        
    STDMETHOD Release, :PTR IDirectSoundBuffer8       

;    // IDirectSoundBuffer methods
    STDMETHOD GetCaps, :PTR IDirectSoundBuffer8               
    STDMETHOD GetCurrentPosition, :PTR IDirectSoundBuffer8    
    STDMETHOD GetFormat, :PTR IDirectSoundBuffer8             
    STDMETHOD GetVolume, :PTR IDirectSoundBuffer8             
    STDMETHOD GetPan, :PTR IDirectSoundBuffer8                
    STDMETHOD GetFrequency, :PTR IDirectSoundBuffer8          
    STDMETHOD GetStatus, :PTR IDirectSoundBuffer8             
    STDMETHOD Initialize, :PTR IDirectSoundBuffer8            
    STDMETHOD _Lock, :PTR IDirectSoundBuffer8                  
    STDMETHOD Play, :PTR IDirectSoundBuffer8                  
    STDMETHOD SetCurrentPosition, :PTR IDirectSoundBuffer8    
    STDMETHOD SetFormat, :PTR IDirectSoundBuffer8             
    STDMETHOD SetVolume, :PTR IDirectSoundBuffer8             
    STDMETHOD SetPan, :PTR IDirectSoundBuffer8                
    STDMETHOD SetFrequency, :PTR IDirectSoundBuffer8          
    STDMETHOD Stop, :PTR IDirectSoundBuffer8                  
    STDMETHOD Unlock, :PTR IDirectSoundBuffer8                
    STDMETHOD Restore, :PTR IDirectSoundBuffer8               

;    // IDirectSoundBuffer8 methods
    STDMETHOD SetFX, :PTR IDirectSoundBuffer8                 
    STDMETHOD AcquireResources, :PTR IDirectSoundBuffer8      
    STDMETHOD GetObjectInPath, :PTR IDirectSoundBuffer8       
IDirectSoundBuffer8 ENDS

IDirectSound3DListener STRUCT
;    // IUnknown methods
    STDMETHOD QueryInterface,   :PTR IDirectSound3DListener8     
    STDMETHOD AddRef,           :PTR IDirectSound3DListener8             
    STDMETHOD Release,          :PTR IDirectSound3DListener8            

;    // IDirectSound3DListener methods
    STDMETHOD GetAllParameters,     :PTR IDirectSound3DListener8          
    STDMETHOD GetDistanceFactor,    :PTR IDirectSound3DListener8         
    STDMETHOD GetDopplerFactor,     :PTR IDirectSound3DListener8          
    STDMETHOD GetOrientation,       :PTR IDirectSound3DListener8            
    STDMETHOD GetPosition,          :PTR IDirectSound3DListener8               
    STDMETHOD GetRolloffFactor,     :PTR IDirectSound3DListener8          
    STDMETHOD GetVelocity,          :PTR IDirectSound3DListener8               
    STDMETHOD SetAllParameters,     :PTR IDirectSound3DListener8          
    STDMETHOD SetDistanceFactor,    :PTR IDirectSound3DListener8, :DWORD, :DWORD         
    STDMETHOD SetDopplerFactor,     :PTR IDirectSound3DListener8, :DWORD, :DWORD          
    STDMETHOD SetOrientation,       :PTR IDirectSound3DListener8            
    STDMETHOD SetPosition,          :PTR IDirectSound3DListener8, :DWORD, :DWORD, :DWORD, :DWORD
    STDMETHOD SetRolloffFactor,     :PTR IDirectSound3DListener8, :DWORD, :DWORD          
    STDMETHOD SetVelocity,          :PTR IDirectSound3DListener8               
    STDMETHOD CommitDeferredSettings, :PTR IDirectSound3DListener8    
IDirectSound3DListener ENDS

; ====================================
;                           MACROS
; ====================================

DS3DBINVOKE	MACRO	func, this, arglist :VARARG
	mov			eax , [this]
	mov			eax , [eax]
	IFB <arglist>
		INVOKE [IDirectSound3DBuffer8. func][eax], this
	ELSE
		INVOKE [IDirectSound3DBuffer8. func][eax], this, arglist
	ENDIF
ENDM

DSBINVOKE	MACRO	func, this, arglist :VARARG
	mov			eax , [this]
	mov			eax , [eax]
	IFB <arglist>
		INVOKE [IDirectSoundBuffer8. func][eax], this
	ELSE
		INVOKE [IDirectSoundBuffer8. func][eax], this, arglist
	ENDIF
ENDM


DSLINVOKE	MACRO	func, this, arglist :VARARG
	mov			eax , [this]
	mov			eax , [eax]
	IFB <arglist>
		INVOKE [IDirectSound3DListener. func][eax], this
	ELSE
		INVOKE [IDirectSound3DListener. func][eax], this, arglist
	ENDIF
ENDM

; ====================================
;                       STRUCTS
; ====================================
WAVEFORMATEX STRUCT
  wFormatTag        dw ?
  nChannels         dw ?
  nSamplesPerSec    dd ? 
  nAvgBytesPerSec   dd ?
  nBlockAlign       dw ?
  wBitsPerSample    dw ?
  cbSize            dw ?
WAVEFORMATEX ENDS


DSBUFFERDESC STRUCT
    dwSize          dd ?
    dwFlags         dd ?
    dwBufferBytes   dd ?
    dwReserved      dd ?
    lpwfxFormat     dd ? ; ptr to WAVEFORMATEX
    guid3DAlgorithm dd ?
DSBUFFERDESC ENDS


; ====================================
;                       EQUS
; ====================================
DS3D_IMMEDIATE              EQU 00000000h

DSCAPS_PRIMARYMONO          EQU 000000001h
DSCAPS_PRIMARYSTEREO        EQU 000000002h
DSCAPS_PRIMARY8BIT          EQU 000000004h
DSCAPS_PRIMARY16BIT         EQU 000000008h
DSCAPS_CONTINUOUSRATE       EQU 000000010h
DSCAPS_EMULDRIVER           EQU 000000020h
DSCAPS_CERTIFIED            EQU 000000040h
DSCAPS_SECONDARYMONO        EQU 000000100h
DSCAPS_SECONDARYSTEREO      EQU 000000200h
DSCAPS_SECONDARY8BIT        EQU 000000400h
DSCAPS_SECONDARY16BIT       EQU 000000800h

DSSCL_NORMAL                EQU 000000001h
DSSCL_PRIORITY              EQU 000000002h
DSSCL_EXCLUSIVE             EQU 000000003h
DSSCL_WRITEPRIMARY          EQU 000000004h

DSSPEAKER_DIRECTOUT         EQU 000000000h
DSSPEAKER_HEADPHONE         EQU 000000001h
DSSPEAKER_MONO              EQU 000000002h
DSSPEAKER_QUAD              EQU 000000003h
DSSPEAKER_STEREO            EQU 000000004h
DSSPEAKER_SURROUND          EQU 000000005h
DSSPEAKER_5POINT1           EQU 000000006h
DSSPEAKER_7POINT1           EQU 000000007h

DSSPEAKER_GEOMETRY_MIN      EQU 000000005h  
DSSPEAKER_GEOMETRY_NARROW   EQU 00000000Ah 
DSSPEAKER_GEOMETRY_WIDE     EQU 000000014h
DSSPEAKER_GEOMETRY_MAX      EQU 0000000B4h  

DSBCAPS_PRIMARYBUFFER       EQU 000000001h
DSBCAPS_STATIC              EQU 000000002h
DSBCAPS_LOCHARDWARE         EQU 000000004h
DSBCAPS_LOCSOFTWARE         EQU 000000008h
DSBCAPS_CTRL3D              EQU 000000010h
DSBCAPS_CTRLFREQUENCY       EQU 000000020h
DSBCAPS_CTRLPAN             EQU 000000040h
DSBCAPS_CTRLVOLUME          EQU 000000080h
DSBCAPS_CTRLPOSITIONNOTIFY  EQU 000000100h
DSBCAPS_CTRLFX              EQU 000000200h
DSBCAPS_STICKYFOCUS         EQU 000004000h
DSBCAPS_GLOBALFOCUS         EQU 000008000h
DSBCAPS_GETCURRENTPOSITION2 EQU 000010000h
DSBCAPS_MUTE3DATMAXDISTANCE EQU 000020000h
DSBCAPS_LOCDEFER            EQU 000040000h

DSBPLAY_LOOPING             EQU 000000001h
DSBPLAY_LOCHARDWARE         EQU 000000002h
DSBPLAY_LOCSOFTWARE         EQU 000000004h
DSBPLAY_TERMINATEBY_TIME    EQU 000000008h
DSBPLAY_TERMINATEBY_DISTANCE    EQU 0000000010h
DSBPLAY_TERMINATEBY_PRIORITY    EQU 0000000020h

DSBSTATUS_PLAYING           EQU 000000001h
DSBSTATUS_BUFFERLOST        EQU 000000002h
DSBSTATUS_LOOPING           EQU 000000004h
DSBSTATUS_LOCHARDWARE       EQU 000000008h
DSBSTATUS_LOCSOFTWARE       EQU 000000010h
DSBSTATUS_TERMINATED        EQU 000000020h

DSBLOCK_FROMWRITECURSOR     EQU 000000001h
DSBLOCK_ENTIREBUFFER        EQU 000000002h

DSBFREQUENCY_ORIGINAL       EQU 0
DSBFREQUENCY_MIN            EQU 100
DSBFREQUENCY_MAX            EQU 200000

DSBPAN_LEFT                 EQU -10000
DSBPAN_CENTER               EQU 0
DSBPAN_RIGHT                EQU 10000

DSBVOLUME_MIN               EQU -10000
DSBVOLUME_MAX               EQU 0

DSBSIZE_MIN                 EQU 4
DSBSIZE_MAX                 EQU 00FFFFFFFh
DSBSIZE_FX_MIN              EQU 150 

DS3DMODE_NORMAL             EQU 000000000h
DS3DMODE_HEADRELATIVE       EQU 000000001h
DS3DMODE_DISABLE            EQU 000000002h

DS3D_IMMEDIATE              EQU 000000000h
DS3D_DEFERRED               EQU 000000001h

DS3D_DEFAULTDISTANCEFACTOR  EQU 1.0

DS3D_MINROLLOFFFACTOR       EQU 0.0
DS3D_MAXROLLOFFFACTOR       EQU 10.0
DS3D_DEFAULTROLLOFFFACTOR   EQU 1.0

DS3D_MINDOPPLERFACTOR       EQU 0.0
DS3D_MAXDOPPLERFACTOR       EQU 10.0
DS3D_DEFAULTDOPPLERFACTOR   EQU 1.0

DS3D_DEFAULTMINDISTANCE     EQU 1.0
DS3D_DEFAULTMAXDISTANCE     EQU 1000000000.0
