    D3DCULL_NONE                EQU     1
    D3DCULL_CW                  EQU     2
    D3DCULL_CCW                 EQU     3

D3DCOLOR TYPEDEF DWORD
;/* Usages */
D3DUSAGE_RENDERTARGET       EQU (000000001h)
D3DUSAGE_DEPTHSTENCIL       EQU (000000002h)

;/* Usages for Vertex/Index buffers */
D3DUSAGE_WRITEONLY          EQU (000000008h)
D3DUSAGE_SOFTWAREPROCESSING EQU (000000010h)
D3DUSAGE_DONOTCLIP          EQU (000000020h)
D3DUSAGE_POINTS             EQU (000000040h)
D3DUSAGE_RTPATCHES          EQU (000000080h)
D3DUSAGE_NPATCHES           EQU (000000100h)
D3DUSAGE_DYNAMIC            EQU (000000200h)

;/* Flexible vertex format bits */
D3DFVF_RESERVED0        EQU 00001h
D3DFVF_POSITION_MASK    EQU 0400Eh
D3DFVF_XYZ              EQU 00002h
D3DVFV_XYZRHW           EQU 00004h
D3DFVF_XYZB1            EQU 00006h
D3DFVF_XYZB2            EQU 00008h
D3DFVF_XYZB3            EQU 0000ah
D3DFVF_XYZB4            EQU 0000ch
D3DFVF_XYZB5            EQU 0000eh
D3DFVF_XYZW             EQU 04002h

D3DFVF_NORMAL           EQU 010h
D3DFVF_PSIZE            EQU 020h
D3DFVF_DIFFUSE          EQU 040h
D3DFVF_SPECULAR         EQU 080h

D3DFVF_TEXCOUNT_MASK    EQU 0f00h
D3DFVF_TEXCOUNT_SHIFT   EQU 0008
D3DFVF_TEX0             EQU 000h
D3DFVF_TEX1             EQU 100h
D3DFVF_TEX2             EQU 200h
D3DFVF_TEX3             EQU 300h
D3DFVF_TEX4             EQU 400h
D3DFVF_TEX5             EQU 500h
D3DFVF_TEX6             EQU 600h
D3DFVF_TEX7             EQU 700h
D3DFVF_TEX8             EQU 800h

D3DFVF_LASTBETA_UBYTE4   EQU 1000h
D3DFVF_LASTBETA_D3DCOLOR EQU 8000h

D3DFVF_RESERVED2         EQU 6000h  ; 2 reserved bits


D3DTS_VIEW equ 2
D3DTS_PROJECTION equ 3
D3DTS_TEXTURE0 equ 16
D3DTS_TEXTURE1 equ 17
D3DTS_TEXTURE2 equ 18 
D3DTS_TEXTURE3 equ 19
D3DTS_TEXTURE4 equ 20
D3DTS_TEXTURE5 equ 21
D3DTS_TEXTURE6 equ 22
D3DTS_TEXTURE7 equ 23


    D3DFMT_UNKNOWN              EQU  0

    D3DFMT_R8G8B8               EQU 20
    D3DFMT_A8R8G8B8             EQU 21
    D3DFMT_X8R8G8B8             EQU 22
    D3DFMT_R5G6B5               EQU 23
    D3DFMT_X1R5G5B5             EQU 24
    D3DFMT_A1R5G5B5             EQU 25
    D3DFMT_A4R4G4B4             EQU 26
    D3DFMT_R3G3B2               EQU 27
    D3DFMT_A8                   EQU 28
    D3DFMT_A8R3G3B2             EQU 29
    D3DFMT_X4R4G4B4             EQU 30
    D3DFMT_A2B10G10R10          EQU 31
    D3DFMT_A8B8G8R8             EQU 32
    D3DFMT_X8B8G8R8             EQU 33
    D3DFMT_G16R16               EQU 34
    D3DFMT_A2R10G10B10          EQU 35
    D3DFMT_A16B16G16R16         EQU 36

    D3DFMT_A8P8                 EQU 40
    D3DFMT_P8                   EQU 41

    D3DFMT_L8                   EQU 50
    D3DFMT_A8L8                 EQU 51
    D3DFMT_A4L4                 EQU 52

    D3DFMT_V8U8                 EQU 60
    D3DFMT_L6V5U5               EQU 61
    D3DFMT_X8L8V8U8             EQU 62
    D3DFMT_Q8W8V8U8             EQU 63
    D3DFMT_V16U16               EQU 64
    D3DFMT_A2W10V10U10          EQU 67
    
    D3DFMT_UYVY                 EQU MAKEFOURCC, 'U', 'Y', 'V', 'Y'
    D3DFMT_UYVY                 EQU MAKEFOURCC, 'U', 'Y', 'V', 'Y'
    D3DFMT_R8G8_B8G8            EQU MAKEFOURCC, 'R', 'G', 'B', 'G'
    D3DFMT_YUY2                 EQU MAKEFOURCC, 'Y', 'U', 'Y', '2'
    D3DFMT_G8R8_G8B8            EQU MAKEFOURCC, 'G', 'R', 'G', 'B'
    D3DFMT_DXT1                 EQU MAKEFOURCC, 'D', 'X', 'T', '1'
    D3DFMT_DXT2                 EQU MAKEFOURCC, 'D', 'X', 'T', '2'
    D3DFMT_DXT3                 EQU MAKEFOURCC, 'D', 'X', 'T', '3'
    D3DFMT_DXT4                 EQU MAKEFOURCC, 'D', 'X', 'T', '4'
    D3DFMT_DXT5                 EQU MAKEFOURCC, 'D', 'X', 'T', '5'

    D3DFMT_D16_LOCKABLE         EQU 70
    D3DFMT_D32                  EQU 71
    D3DFMT_D15S1                EQU 73
    D3DFMT_D24S8                EQU 75
    D3DFMT_D24X8                EQU 77
    D3DFMT_D24X4S4              EQU 79
    D3DFMT_D16                  EQU 80

    D3DFMT_D32F_LOCKABLE        EQU 82
    D3DFMT_D24FS8               EQU 83


    D3DFMT_L16                  EQU 81

    D3DFMT_VERTEXDATA           EQU 100
    D3DFMT_INDEX16              EQU 101
    D3DFMT_INDEX32              EQU 102

    D3DFMT_Q16W16V16U16         EQU 110

    D3DFMT_MULTI2_ARGB8         EQU MAKEFOURCC, 'M','E','T','1'

    D3DFMT_R16F                 EQU 111
    D3DFMT_G16R16F              EQU 112
    D3DFMT_A16B16G16R16F        EQU 113

    D3DFMT_R32F                 EQU 114
    D3DFMT_G32R32F              EQU 115
    D3DFMT_A32B32G32R32F        EQU 116

    D3DFMT_CxV8U8               EQU 117


    D3DFMT_FORCE_DWORD          EQU 07fffffffh

    D3DLIGHT_POINT          EQU 1
    D3DLIGHT_SPOT           EQU 2
    D3DLIGHT_DIRECTIONAL    EQU 3
    D3DLIGHT_FORCE_DWORD    EQU 07fffffffh 

;/*
; * The following defines the rendering states
; */

    D3DSHADE_FLAT               EQU 1
    D3DSHADE_GOURAUD            EQU 2
    D3DSHADE_PHONG              EQU 3
    D3DSHADE_FORCE_DWORD        EQU 07fffffffh ; /* force 32-bit size enum */

    D3DFILL_POINT               EQU 1
    D3DFILL_WIREFRAME           EQU 2
    D3DFILL_SOLID               EQU 3
    D3DFILL_FORCE_DWORD         EQU 07fffffffh ; /* force 32-bit size enum */

    D3DBLEND_ZERO               EQU 1
    D3DBLEND_ONE                EQU 2
    D3DBLEND_SRCCOLOR           EQU 3
    D3DBLEND_INVSRCCOLOR        EQU 4
    D3DBLEND_SRCALPHA           EQU 5
    D3DBLEND_INVSRCALPHA        EQU 6
    D3DBLEND_DESTALPHA          EQU 7
    D3DBLEND_INVDESTALPHA       EQU 8
    D3DBLEND_DESTCOLOR          EQU 9
    D3DBLEND_INVDESTCOLOR       EQU 10
    D3DBLEND_SRCALPHASAT        EQU 11
    D3DBLEND_BOTHSRCALPHA       EQU 12
    D3DBLEND_BOTHINVSRCALPHA    EQU 13
    D3DBLEND_BLENDFACTOR        EQU 14 ;/* Only supported if D3DPBLENDCAPS_BLENDFACTOR is on */
    D3DBLEND_INVBLENDFACTOR     EQU 15 ;/* Only supported if D3DPBLENDCAPS_BLENDFACTOR is on */
    D3DBLEND_FORCE_DWORD        EQU 07fffffffh ; /* force 32-bit size enum */

    D3DBLENDOP_ADD              EQU 1
    D3DBLENDOP_SUBTRACT         EQU 2
    D3DBLENDOP_REVSUBTRACT      EQU 3
    D3DBLENDOP_MIN              EQU 4
    D3DBLENDOP_MAX              EQU 5
    D3DBLENDOP_FORCE_DWORD      EQU 07fffffffh ; /* force 32-bit size enum */

    D3DTADDRESS_WRAP            EQU 1
    D3DTADDRESS_MIRROR          EQU 2
    D3DTADDRESS_CLAMP           EQU 3
    D3DTADDRESS_BORDER          EQU 4
    D3DTADDRESS_MIRRORONCE      EQU 5
    D3DTADDRESS_FORCE_DWORD     EQU 07fffffffh ; /* force 32-bit size enum */

    D3DCULL_NONE                EQU 1
    D3DCULL_CW                  EQU 2
    D3DCULL_CCW                 EQU 3
    D3DCULL_FORCE_DWORD         EQU 07fffffffh ; /* force 32-bit size enum */

    D3DCMP_NEVER                EQU 1
    D3DCMP_LESS                 EQU 2
    D3DCMP_EQUAL                EQU 3
    D3DCMP_LESSEQUAL            EQU 4
    D3DCMP_GREATER              EQU 5
    D3DCMP_NOTEQUAL             EQU 6
    D3DCMP_GREATEREQUAL         EQU 7
    D3DCMP_ALWAYS               EQU 8
    D3DCMP_FORCE_DWORD          EQU 07fffffffh ; /* force 32-bit size enum */

    D3DSTENCILOP_KEEP           EQU 1
    D3DSTENCILOP_ZERO           EQU 2
    D3DSTENCILOP_REPLACE        EQU 3
    D3DSTENCILOP_INCRSAT        EQU 4
    D3DSTENCILOP_DECRSAT        EQU 5
    D3DSTENCILOP_INVERT         EQU 6
    D3DSTENCILOP_INCR           EQU 7
    D3DSTENCILOP_DECR           EQU 8
    D3DSTENCILOP_FORCE_DWORD    EQU 07fffffffh ; /* force 32-bit size enum */

    D3DFOG_NONE                 EQU 0
    D3DFOG_EXP                  EQU 1
    D3DFOG_EXP2                 EQU 2
    D3DFOG_LINEAR               EQU 3
    D3DFOG_FORCE_DWORD          EQU 07fffffffh ; /* force 32-bit size enum */

    D3DZB_FALSE                 EQU 0
    D3DZB_TRUE                  EQU 1 // Z buffering
    D3DZB_USEW                  EQU 2 // W buffering
    D3DZB_FORCE_DWORD           EQU 07fffffffh ; /* force 32-bit size enum */

;// Primitives supported by draw-primitive API
    D3DPT_POINTLIST             EQU 1
    D3DPT_LINELIST              EQU 2
    D3DPT_LINESTRIP             EQU 3
    D3DPT_TRIANGLELIST          EQU 4
    D3DPT_TRIANGLESTRIP         EQU 5
    D3DPT_TRIANGLEFAN           EQU 6
    D3DPT_FORCE_DWORD           EQU 07fffffffh ; /* force 32-bit size enum */

    D3DTS_VIEW          EQU 2
    D3DTS_PROJECTION    EQU 3
    D3DTS_TEXTURE0      EQU 16
    D3DTS_TEXTURE1      EQU 17
    D3DTS_TEXTURE2      EQU 18
    D3DTS_TEXTURE3      EQU 19
    D3DTS_TEXTURE4      EQU 20
    D3DTS_TEXTURE5      EQU 21
    D3DTS_TEXTURE6      EQU 22
    D3DTS_TEXTURE7      EQU 23
    D3DTS_FORCE_DWORD     EQU 07fffffffh ; /* force 32-bit size enum */

; Tipo de filtro de textura
	D3DTEXF_NONE EQU 0 
    D3DTEXF_POINT EQU 1 
    D3DTEXF_LINEAR EQU 2 
    D3DTEXF_ANISOTROPIC EQU 3 
    D3DTEXF_PYRAMIDALQUAD EQU 6 
    D3DTEXF_GAUSSIANQUAD EQU 7 
    D3DTEXF_FORCE_DWORD EQU 0x7fffffff 

;/*
; * State enumerants for per-sampler texture processing.
; */
    D3DSAMP_ADDRESSU       EQU 1 ;  /* D3DTEXTUREADDRESS for U coordinate */
    D3DSAMP_ADDRESSV       EQU 2 ;  /* D3DTEXTUREADDRESS for V coordinate */
    D3DSAMP_ADDRESSW       EQU 3 ;  /* D3DTEXTUREADDRESS for W coordinate */
    D3DSAMP_BORDERCOLOR    EQU 4 ;  /* D3DCOLOR */
    D3DSAMP_MAGFILTER      EQU 5 ;  /* D3DTEXTUREFILTER filter to use for magnification */
    D3DSAMP_MINFILTER      EQU 6 ;  /* D3DTEXTUREFILTER filter to use for minification */
    D3DSAMP_MIPFILTER      EQU 7 ;  /* D3DTEXTUREFILTER filter to use between mipmaps during minification */
    D3DSAMP_MIPMAPLODBIAS  EQU 8 ;  /* float Mipmap LOD bias */
    D3DSAMP_MAXMIPLEVEL    EQU 9 ;  /* DWORD 0..(n-1) LOD index of largest map to use (0 == largest) */
    D3DSAMP_MAXANISOTROPY  EQU 10 ; /* DWORD maximum anisotropy */
    D3DSAMP_SRGBTEXTURE    EQU 11 ; /* Default = 0 (which means Gamma 1.0,
;                                   no correction required.) else correct for
;                                   Gamma = 2.2 */
    D3DSAMP_ELEMENTINDEX   EQU 12 ; /* When multi-element texture is assigned to sampler, this
;                                    indicates which element index to use.  Default = 0.  */
    D3DSAMP_DMAPOFFSET     EQU 13 ; /* Offset in vertices in the pre-sampled displacement map.
;                                    Only valid for D3DDMAPSAMPLER sampler  */
    D3DSAMP_FORCE_DWORD   EQU 0x7fffffff ; /* force 32-bit size enum */

; ************************ Estructuras *****************************
D3DDISPLAYMODE STRUCT
    _Width 		dd ?
    Height 		dd ?
    RefreshRate	dd ?
    Format		dd ?
D3DDISPLAYMODE ENDS

_D3DMATRIX struct   DWORD
    _11		FLOAT		?
    _12		FLOAT		?
    _13		FLOAT		?
    _14		FLOAT		?
    _21		FLOAT		?
    _22		FLOAT		?
    _23		FLOAT		?
    _24		FLOAT		?
    _31		FLOAT		?
    _32		FLOAT		?
    _33		FLOAT		?
    _34		FLOAT		?
    _41		FLOAT		?
    _42		FLOAT		?
    _43		FLOAT		?
    _44		FLOAT		?
_D3DMATRIX  ENDS
D3DMATRIX       TYPEDEF		_D3DMATRIX
D3DXMATRIX      EQU <D3DMATRIX>
LPD3DMATRIX		TYPEDEF		PTR _D3DMATRIX

_D3DXVECTOR2		struct

    x			FLOAT		?
    y			FLOAT		?

_D3DXVECTOR2		ends
D3DXVECTOR2		typedef		_D3DXVECTOR2
LPD3DXVECTOR2		typedef	ptr	D3DXVECTOR2

_D3DXVECTOR3		struct

    x			FLOAT		?
    y			FLOAT		?
    z			FLOAT		?

_D3DXVECTOR3		ends
D3DXVECTOR3		typedef		_D3DXVECTOR3
LPD3DXVECTOR3		typedef	ptr	D3DXVECTOR3

_D3DXVECTOR4		struct
    x			FLOAT		?
    y			FLOAT		?
    z			FLOAT		?
    w			FLOAT		?
_D3DXVECTOR4		ends
D3DXVECTOR4		typedef		_D3DXVECTOR4
LPD3DXVECTOR4		typedef	ptr	D3DXVECTOR4
D3DXQUATERNION		typedef		D3DXVECTOR4
LPD3DXQUATERNION	typedef	ptr	D3DXVECTOR4
D3DCOLORVALUE STRUCT
	r FLOAT ?
	g FLOAT ?
	b FLOAT ?
	a FLOAT ?
D3DCOLORVALUE EndS
D3DMATERIAL9 STRUCT
	Diffuse		D3DCOLORVALUE <>;        /* Diffuse color RGBA */
    Ambient		D3DCOLORVALUE <>;        /* Ambient color RGB */
    Specular	D3DCOLORVALUE <>;       /* Specular 'shininess' */
    Emissive	D3DCOLORVALUE <>;       /* Emissive color RGB */
    Power 		FLOAT ?;          /* Sharpness if specular highlight */
D3DMATERIAL9 EndS
D3DXMATERIAL STRUCT
    MatD3D 		D3DMATERIAL9 <>
    pTextureFilename dd ?
D3DXMATERIAL ENDS
LPD3DXMATERIAL typedef PTR D3DXMATERIAL

D3DVECTOR STRUCT
    x	FLOAT ?
    y	FLOAT ?
    z	FLOAT ?
D3DVECTOR ENDS
D3DLIGHT9 STRUCT
    _Type					dd ?;       /* Type of light source */
    Diffuse D3DCOLORVALUE <>;         /* Diffuse color of light */
    Specular D3DCOLORVALUE <>;         /* Specular color of light */
    Ambient D3DCOLORVALUE <>;         /* Ambient color of light */
    Position D3DVECTOR <>;         /* Position in world space */
    Direction D3DVECTOR <>;         /* Direction in world space */
    Range FLOAT ?;            /* Cutoff range */
    Falloff FLOAT ?;          /* Falloff */
    Attenuation0 FLOAT ?;     /* Constant attenuation */
    Attenuation1 FLOAT ?;     /* Linear attenuation */
    Attenuation2 FLOAT ?;     /* Quadratic attenuation */
    Theta FLOAT ?;            /* Inner angle of spotlight cone */
    Phi FLOAT ?;              /* Outer angle of spotlight cone */
D3DLIGHT9 EndS
D3DLOCKED_RECT STRUCT
	Pitch DWORD ?
    pBits DWORD ?
D3DLOCKED_RECT EndS
D3DSURFACE_DESC STRUCT
    Format DD ?
    _Type DD ?
    Usage DD ?
    Pool DD ?
    MultiSampleType DD ?
    MultiSampleQuality DD ?
    _Width DD ?
    Height DD ?
D3DSURFACE_DESC EndS
;/*
; * State enumerants for per-stage processing of fixed function pixel processing
; * Two of these affect fixed function vertex processing as well: TEXTURETRANSFORMFLAGS and TEXCOORDINDEX.
; */
    D3DTSS_COLOROP        EQU  1 ; /* D3DTEXTUREOP - per-stage blending controls for color channels */
    D3DTSS_COLORARG1      EQU  2 ; /* D3DTA_* (texture arg) */
    D3DTSS_COLORARG2      EQU  3 ; /* D3DTA_* (texture arg) */
    D3DTSS_ALPHAOP        EQU  4 ; /* D3DTEXTUREOP - per-stage blending controls for alpha channel */
    D3DTSS_ALPHAARG1      EQU  5 ; /* D3DTA_* (texture arg) */
    D3DTSS_ALPHAARG2      EQU  6 ; /* D3DTA_* (texture arg) */
    D3DTSS_BUMPENVMAT00   EQU  7 ; /* float (bump mapping matrix) */
    D3DTSS_BUMPENVMAT01   EQU  8 ; /* float (bump mapping matrix) */
    D3DTSS_BUMPENVMAT10   EQU  9 ; /* float (bump mapping matrix) */
    D3DTSS_BUMPENVMAT11   EQU 10 ; /* float (bump mapping matrix) */
    D3DTSS_TEXCOORDINDEX  EQU 11 ; /* identifies which set of texture coordinates index this texture */
    D3DTSS_BUMPENVLSCALE  EQU 22 ; /* float scale for bump map luminance */
    D3DTSS_BUMPENVLOFFSET EQU 23 ; /* float offset for bump map luminance */
    D3DTSS_TEXTURETRANSFORMFLAGS EQU 24 ; /* D3DTEXTURETRANSFORMFLAGS controls texture transform */
    D3DTSS_COLORARG0      EQU 26 ; /* D3DTA_* third arg for triadic ops */
    D3DTSS_ALPHAARG0      EQU 27 ; /* D3DTA_* third arg for triadic ops */
    D3DTSS_RESULTARG      EQU 28 ; /* D3DTA_* arg for result (CURRENT or TEMP) */
    D3DTSS_CONSTANT       EQU 32 ; /* Per-stage constant D3DTA_CONSTANT */
    D3DTSS_FORCE_DWORD   EQU 07fffffffh ; /* force 32-bit size enum */

;/*
; * Enumerations for COLOROP and ALPHAOP texture blending operations set in
; * texture processing stage controls in D3DTSS.
; */
;    // Control
    D3DTOP_DISABLE              EQU 1 ;      // disables stage
    D3DTOP_SELECTARG1           EQU 2 ;      // the default
    D3DTOP_SELECTARG2           EQU 3 ;

;    // Modulate
    D3DTOP_MODULATE             EQU 4 ;      // multiply args together
    D3DTOP_MODULATE2X           EQU 5 ;      // multiply and  1 bit
    D3DTOP_MODULATE4X           EQU 6 ;      // multiply and  2 bits

;    // Add
    D3DTOP_ADD                  EQU  7 ;   // add arguments together
    D3DTOP_ADDSIGNED            EQU  8 ;   // add with -0.5 bias
    D3DTOP_ADDSIGNED2X          EQU  9 ;   // as above but left  1 bit
    D3DTOP_SUBTRACT             EQU 10 ;   // Arg1 - Arg2, with no saturation
    D3DTOP_ADDSMOOTH            EQU 11 ;   // add 2 args, subtract product
;                                        // Arg1 + Arg2 - Arg1*Arg2
;                                        // = Arg1 + (1-Arg1)*Arg2

;    // Linear alpha blend: Arg1*(Alpha) + Arg2*(1-Alpha)
    D3DTOP_BLENDDIFFUSEALPHA    EQU 12 ; // iterated alpha
    D3DTOP_BLENDTEXTUREALPHA    EQU 13 ; // texture alpha
    D3DTOP_BLENDFACTORALPHA     EQU 14 ; // alpha from D3DRS_TEXTUREFACTOR

;    // Linear alpha blend with pre-multiplied arg1 input: Arg1 + Arg2*(1-Alpha)
    D3DTOP_BLENDTEXTUREALPHAPM  EQU 15 ; // texture alpha
    D3DTOP_BLENDCURRENTALPHA    EQU 16 ; // by alpha of current color

;    // Specular mapping
    D3DTOP_PREMODULATE            EQU 17 ;     // modulate with next texture before use
    D3DTOP_MODULATEALPHA_ADDCOLOR EQU 18 ;     // Arg1.RGB + Arg1.A*Arg2.RGB
;                                            // COLOROP only
    D3DTOP_MODULATECOLOR_ADDALPHA EQU 19 ;     // Arg1.RGB*Arg2.RGB + Arg1.A
;                                            // COLOROP only
    D3DTOP_MODULATEINVALPHA_ADDCOLOR EQU 20 ;  // (1-Arg1.A)*Arg2.RGB + Arg1.RGB
;                                            // COLOROP only
    D3DTOP_MODULATEINVCOLOR_ADDALPHA EQU 21 ;  // (1-Arg1.RGB)*Arg2.RGB + Arg1.A
;                                            // COLOROP only
;    // Bump mapping
    D3DTOP_BUMPENVMAP           EQU 22 ; // per pixel env map perturbation
    D3DTOP_BUMPENVMAPLUMINANCE  EQU 23 ; // with luminance channel
;    // This can do either diffuse or specular bump mapping with correct input.
;    // Performs the function (Arg1.R*Arg2.R + Arg1.G*Arg2.G + Arg1.B*Arg2.B)
;    // where each component has been scaled and offset to make it signed.
;    // The result is replicated into all four (including alpha) channels.
;    // This is a valid COLOROP only.
    D3DTOP_DOTPRODUCT3          EQU 24 ;
;    // Triadic ops
    D3DTOP_MULTIPLYADD          EQU 25 ; // Arg0 + Arg1*Arg2
    D3DTOP_LERP                 EQU 26 ; // (Arg0)*Arg1 + (1-Arg0)*Arg2
    D3DTOP_FORCE_DWORD EQU 07fffffffh 
;/*
; * Values for COLORARG0,1,2, ALPHAARG0,1,2, and RESULTARG texture blending
; * operations set in texture processing stage controls in D3DRENDERSTATE.
; */
D3DTA_SELECTMASK        EQU 00000000fh  ; // mask for arg selector
D3DTA_DIFFUSE           EQU 000000000h  ; // select diffuse color (read only)
D3DTA_CURRENT           EQU 000000001h  ; // select stage destination register (read/write)
D3DTA_TEXTURE           EQU 000000002h  ; // select texture color (read only)
D3DTA_TFACTOR           EQU 000000003h  ; // select D3DRS_TEXTUREFACTOR (read only)
D3DTA_SPECULAR          EQU 000000004h  ; // select specular color (read only)
D3DTA_TEMP              EQU 000000005h  ; // select temporary register color (read/write)
D3DTA_CONSTANT          EQU 000000006h  ; // select texture stage constant
D3DTA_COMPLEMENT        EQU 000000010h  ; // take 1.0 - x (read modifier)
D3DTA_ALPHAREPLICATE    EQU 000000020h  ; // replicate alpha to color components (read modifier)

D3DTTFF_DISABLE         EQU 0 ;    // texture coordinates are passed directly
D3DTTFF_COUNT1          EQU 1 ;    // rasterizer should expect 1-D texture coords
D3DTTFF_COUNT2          EQU 2 ;    // rasterizer should expect 2-D texture coords
D3DTTFF_COUNT3          EQU 3 ;    // rasterizer should expect 3-D texture coords
D3DTTFF_COUNT4          EQU 4 ;    // rasterizer should expect 4-D texture coords
D3DTTFF_PROJECTED       EQU 256 ;  // texcoords to be divided by COUNTth element
D3DTTFF_FORCE_DWORD     EQU 07fffffffh ;

D3DTSS_TCI_PASSTHRU                             EQU 000000000h
D3DTSS_TCI_CAMERASPACENORMAL                    EQU 000010000h
D3DTSS_TCI_CAMERASPACEPOSITION                  EQU 000020000h
D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR          EQU 000030000h
D3DTSS_TCI_SPHEREMAP                            EQU 000040000h

;// Mesh options - lower 3 bytes only, upper byte used by _D3DXMESHOPT option flags
    D3DXMESH_32BIT                  EQU 0001h ; // If set, then use 32 bit indices, if not set use 16 bit indices.
    D3DXMESH_DONOTCLIP              EQU 0002h ; // Use D3DUSAGE_DONOTCLIP for VB & IB.
    D3DXMESH_POINTS                 EQU 0004h ; // Use D3DUSAGE_POINTS for VB & IB. 
    D3DXMESH_RTPATCHES              EQU 0008h ; // Use D3DUSAGE_RTPATCHES for VB & IB. 
    D3DXMESH_NPATCHES               EQU 04000h ;// Use D3DUSAGE_NPATCHES for VB & IB. 
    D3DXMESH_VB_SYSTEMMEM           EQU 0010h ; // Use D3DPOOL_SYSTEMMEM for VB. Overrides D3DXMESH_MANAGEDVERTEXBUFFER
    D3DXMESH_VB_MANAGED             EQU 0020h ; // Use D3DPOOL_MANAGED for VB. 
    D3DXMESH_VB_WRITEONLY           EQU 0040h ; // Use D3DUSAGE_WRITEONLY for VB.
    D3DXMESH_VB_DYNAMIC             EQU 0080h ; // Use D3DUSAGE_DYNAMIC for VB.
    D3DXMESH_VB_SOFTWAREPROCESSING	EQU 08000h ; // Use D3DUSAGE_SOFTWAREPROCESSING for VB.
    D3DXMESH_IB_SYSTEMMEM           EQU 0100h ; // Use D3DPOOL_SYSTEMMEM for IB. Overrides D3DXMESH_MANAGEDINDEXBUFFER
    D3DXMESH_IB_MANAGED             EQU 0200h ; // Use D3DPOOL_MANAGED for IB.
    D3DXMESH_IB_WRITEONLY           EQU 0400h ; // Use D3DUSAGE_WRITEONLY for IB.
    D3DXMESH_IB_DYNAMIC             EQU 0800h ; // Use D3DUSAGE_DYNAMIC for IB.
    D3DXMESH_IB_SOFTWAREPROCESSING	EQU 010000h ; // Use D3DUSAGE_SOFTWAREPROCESSING for IB.
    D3DXMESH_VB_SHARE               EQU 01000h ; // Valid for Clone* calls only, forces cloned mesh/pmesh to share vertex buffer
    D3DXMESH_USEHWONLY              EQU 02000h ; // Valid for ID3DXSkinMesh::ConvertToBlendedMesh
;    // Helper options
    D3DXMESH_SYSTEMMEM              EQU 0110h ; // D3DXMESH_VB_SYSTEMMEM | D3DXMESH_IB_SYSTEMMEM
    D3DXMESH_MANAGED                EQU 0220h ; // D3DXMESH_VB_MANAGED | D3DXMESH_IB_MANAGED
    D3DXMESH_WRITEONLY              EQU 0440h ; // D3DXMESH_VB_WRITEONLY | D3DXMESH_IB_WRITEONLY
    D3DXMESH_DYNAMIC                EQU 0880h ; // D3DXMESH_VB_DYNAMIC | D3DXMESH_IB_DYNAMIC
    D3DXMESH_SOFTWAREPROCESSING   	EQU 018000h ; // D3DXMESH_VB_SOFTWAREPROCESSING | D3DXMESH_IB_SOFTWAREPROCESSING

  	D3DXMESHSIMP_VERTEX 			EQU 1
    D3DXMESHSIMP_FACE 				EQU 2

; D3DMULTISAMPLE_TYPE 
    D3DMULTISAMPLE_NONE EQU  0
    D3DMULTISAMPLE_NONMASKABLE EQU  1
    D3DMULTISAMPLE_2_SAMPLES EQU  2
    D3DMULTISAMPLE_3_SAMPLES EQU  3
    D3DMULTISAMPLE_4_SAMPLES EQU  4
    D3DMULTISAMPLE_5_SAMPLES EQU  5
    D3DMULTISAMPLE_6_SAMPLES EQU  6
    D3DMULTISAMPLE_7_SAMPLES EQU  7
    D3DMULTISAMPLE_8_SAMPLES EQU  8
    D3DMULTISAMPLE_9_SAMPLES EQU  9
    D3DMULTISAMPLE_10_SAMPLES EQU  10
    D3DMULTISAMPLE_11_SAMPLES EQU  11
    D3DMULTISAMPLE_12_SAMPLES EQU  12
    D3DMULTISAMPLE_13_SAMPLES EQU  13
    D3DMULTISAMPLE_14_SAMPLES EQU  14
    D3DMULTISAMPLE_15_SAMPLES EQU  15
    D3DMULTISAMPLE_16_SAMPLES EQU  16
    D3DMULTISAMPLE_FORCE_DWORD EQU  0xffffffff


;*************************** Macros ******************
D3DCOLOR_RGBA MACRO R, G, B, A
	EXITM <(A AND 0FFh) SHL 24 OR (R AND 0FFh) SHL 16 OR (G AND 0ffh) SHL 8 OR (B AND 0FFh)> 
ENDM
D3DCOLOR_ARGB MACRO A, R, G, B
	EXITM <D3DCOLOR_RGBA (R, G, B, A)>
ENDM
D3DCOLOR_RGB MACRO R, G, B
	EXITM <D3DCOLOR_RGBA (R, G, B, 0)>
ENDM
D3DTS_WORLDMATRIX MACRO index
    EXITM <index + 256>
 ENDM
D3DTS_WORLD  equ D3DTS_WORLDMATRIX(0)
D3DTS_WORLD1 equ D3DTS_WORLDMATRIX(1)
D3DTS_WORLD2 equ D3DTS_WORLDMATRIX(2)
D3DTS_WORLD3 equ D3DTS_WORLDMATRIX(3)
